"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ws_1 = __importDefault(require("ws"));
var ataraxia_ws_client_1 = require("ataraxia-ws-client");
var transport_1 = require("ataraxia/transport");
var WebSocketServerTransport = /** @class */ (function (_super) {
    __extends(WebSocketServerTransport, _super);
    function WebSocketServerTransport(options) {
        var _this = _super.call(this, 'ws-server') || this;
        if (!options) {
            throw new Error('WebSocketServerTransport requires options, such as a port');
        }
        _this.options = options;
        return _this;
    }
    WebSocketServerTransport.prototype.start = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var started, server_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, _super.prototype.start.call(this, options)];
                    case 1:
                        started = _a.sent();
                        if (!started)
                            return [2 /*return*/, false];
                        this.server = new ws_1.default.Server(this.options);
                        this.server.on('connection', function (socket) {
                            var peer = new WebsocketServerPeer(_this.network);
                            _this.addPeer(peer);
                            peer.setSocket(socket);
                        });
                        this.server.on('error', function (err) {
                            _this.debug('Ignoring error:', err);
                        });
                        if (!this.options.server && !this.options.noServer) {
                            server_1 = this.server;
                            return [2 /*return*/, new Promise(function (resolve) {
                                    return server_1.on('listening', function () { return resolve(true); });
                                })];
                        }
                        return [2 /*return*/, true];
                }
            });
        });
    };
    WebSocketServerTransport.prototype.stop = function () {
        return __awaiter(this, void 0, void 0, function () {
            var stopped, server_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, _super.prototype.stop.call(this)];
                    case 1:
                        stopped = _a.sent();
                        if (!stopped)
                            return [2 /*return*/, false];
                        if (!this.server) return [3 /*break*/, 3];
                        server_2 = this.server;
                        return [4 /*yield*/, new Promise(function (resolve) {
                                return server_2.close(function () { return resolve(); });
                            })];
                    case 2:
                        _a.sent();
                        this.server = undefined;
                        _a.label = 3;
                    case 3: return [2 /*return*/, true];
                }
            });
        });
    };
    return WebSocketServerTransport;
}(transport_1.AbstractTransport));
exports.WebSocketServerTransport = WebSocketServerTransport;
var WebsocketServerPeer = /** @class */ (function (_super) {
    __extends(WebsocketServerPeer, _super);
    function WebsocketServerPeer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    WebsocketServerPeer.prototype.setSocket = function (socket) {
        _super.prototype.setSocket.call(this, socket);
        this.negotiateAsServer();
    };
    return WebsocketServerPeer;
}(ataraxia_ws_client_1.AbstractWebSocketPeer));
//# sourceMappingURL=WebSocketServerTransport.js.map